package cn.wise.sc.cement.tcdri.entity;

import cn.wise.sc.cement.tcdri.model.BaseEntity;
import cn.wise.sc.cement.tcdri.model.query.ClientQuery;
import cn.wise.sc.cement.tcdri.model.vo.ClientVo;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

import java.io.Serializable;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.beans.BeanUtils;

/**
 * <p>
 * 委托单位
 * </p>
 *
 * @author ztw
 * @since 2020-08-07
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class Client extends BaseEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    public static Client crate(final ClientQuery clientQuery) {
        Client newClient = new Client();
        BeanUtils.copyProperties(clientQuery, newClient);
        newClient.setStatus(true);
        return newClient;
    }


    @Override
    public ClientVo toVo() {
        ClientVo clientVo = new ClientVo();
        BeanUtils.copyProperties(this, clientVo, "status");
        clientVo.setStatus(this.getStatus() ? "启用" : "禁用");
        return clientVo;
    }


    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 单位名
     */
    private String name;

    /**
     * 负责人
     */
    private String principal;

    /**
     * 负责人电话
     */
    private String principalPhone;

    /**
     * 所在地区:xx省xx县xx
     */
    private String region;

    /**
     * 状态 0:禁用 1:激活
     */
    private Boolean status;

}
