package cn.wise.sc.cement.tcdri.entity;

import cn.wise.sc.cement.tcdri.model.BaseEntity;
import cn.wise.sc.cement.tcdri.model.query.ProjectQuery;
import cn.wise.sc.cement.tcdri.model.vo.ProjectVo;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

import java.io.Serializable;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.beans.BeanUtils;

/**
 * <p>
 * 委托项目
 * </p>
 *
 * @author ztw
 * @since 2020-08-07
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class Project extends BaseEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    public static Project crate(ProjectQuery query) {
        Project newObj = new Project();
        BeanUtils.copyProperties(query, newObj);
        newObj.setStatus(true);
        return newObj;
    }


    @Override
    public ProjectVo toVo() {
        ProjectVo projectVo = new ProjectVo();
        BeanUtils.copyProperties(this, projectVo, "status", "client_id");
        projectVo.setStatus(this.getStatus() ? "启用" : "禁用");
        return projectVo;
    }


    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 项目名
     */
    private String name;

    /**
     * 项目编号:客户自己填的
     */
    private String code;

    /**
     * 客户id
     */
    private Integer clientId;

    /**
     * 状态0:禁用 1:启用
     */
    private Boolean status;

}
