package cn.wise.sc.cement.tcdri.service;

import cn.wise.sc.cement.tcdri.entity.Client;
import cn.wise.sc.cement.tcdri.model.BaseResponse;
import cn.wise.sc.cement.tcdri.model.PageQuery;
import cn.wise.sc.cement.tcdri.model.query.ClientQuery;
import cn.wise.sc.cement.tcdri.model.vo.ClientVo;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author ztw
 * @since 2020-08-07
 */
public interface IClientService extends IService<Client> {


    /**
     * 获取分页
     * @param pageQuery 分页
     * @param status 状态
     * @param region 所在地区
     * @param principal 负责人名字
     * @return IPage<ClientVo>
     */
    BaseResponse<IPage<ClientVo>> getPage(PageQuery pageQuery, Integer status, String region, String principal);

    /**
     * 获取所有启动的单位信息
     *
     * @return List
     */
    BaseResponse<List<ClientVo>> getList();

    /**
     * 新增委托单位
     *
     * @param clientQuery query
     * @return ClientVo
     */
    BaseResponse<ClientVo> create(final ClientQuery clientQuery);

    /**
     * 更新委托单位
     *
     * @param clientQuery query
     * @return ClientVo
     */
    BaseResponse<ClientVo> update(final ClientQuery clientQuery);

    /**
     * 启用禁用
     *
     * @param status 状态
     * @param id     id
     * @return Boolean
     */
    BaseResponse<Boolean> status(Integer status, Integer id);
}
