package cn.wise.sc.cement.tcdri.service;

import cn.wise.sc.cement.tcdri.entity.Project;
import cn.wise.sc.cement.tcdri.model.BaseResponse;
import cn.wise.sc.cement.tcdri.model.PageQuery;
import cn.wise.sc.cement.tcdri.model.query.ProjectQuery;
import cn.wise.sc.cement.tcdri.model.vo.ProjectVo;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author ztw
 * @since 2020-08-07
 */
public interface IProjectService extends IService<Project> {


    /**
     * 获取分页
     *
     * @param pageQuery 分页
     * @param status    状态
     * @param clientId  委托方单位id
     * @return IPage<ProjectVo>
     */
    BaseResponse<IPage<ProjectVo>> getPage(PageQuery pageQuery, Integer status, Integer clientId);

    /**
     * 获取所有启动的单位信息
     *
     * @return List
     */
    BaseResponse<List<ProjectVo>> getList();

    /**
     * 新增项目
     *
     * @param query query
     * @return ProjectVo
     */
    BaseResponse<ProjectVo> create(ProjectQuery query);

    /**
     * 编辑
     *
     * @param query query
     * @return ProjectVo
     */
    BaseResponse<ProjectVo> update(ProjectQuery query);

    /**
     * 启用禁用
     *
     * @param status 状态
     * @param id     id
     * @return Boolean
     */
    BaseResponse<Boolean> status(Integer status, Integer id);
}
